; fp.l -*- Scheme -*-


upper  [A-Z]
lower  [a-z]
digit  [0-9]

%%

[nN][bB]\.                       (let loop () 
				    (let ((c (yygetc)))
				      (cond ((eq? 'eof c) (lexer-error "unexpected end of comment"))
					    ((char=? #\newline c) (yycontinue))
					    (else (loop)))))
\"                               (let loop ([cs '()])
				   (let ([c (yygetc)])
				     (cond [(eq? 'eof c)
					    (parse-error "unexpected end of string constant")]
					   [(char=? c #\\) (loop (cons (escaped-char (yygetc)) cs))]
					   [(char=? c #\")
					    (tok (ATOM ,(string->symbol (reverse-list->string cs))) )]
					   [else (loop (cons c cs))] ) ) )
\$.                                (tok (CHAR ,(string-ref yytext 1)))
"..."                              (tok (DOTS))
"."                                (tok (DOT))
"debug"                            (tok (DEBUG))
"verbatim"                         (tok (VERBATIM))
"where"                            (tok (WHERE))
"end"                              (tok (END))
"while"                            (tok (WHILE))
"bu"                               (tok (BU))
"catch"                            (tok (CATCH))
({lower})({lower}|{upper}|_|'|{digit})*    (tok (ID ,(string->symbol yytext)))
({upper})({upper}|{lower}|_|{digit})*      (tok (ATOM ,(string->symbol yytext)))
0(x|X)({digit}|{lower}|{upper})+   (tok (NUM ,(string->number (substring yytext 2 (string-length yytext)) 16)))
-?{digit}+/{digit}+                (tok (NUM ,(string->number yytext)))
-?{digit}+(\.{digit}+)?            (tok (NUM ,(string->number yytext)))
"->"                               (tok (ARROW))
";"                                (tok (SEMICOLON))
"<"                                (tok (OPEN-SEQUENCE))
">"                                (tok (CLOSE-SEQUENCE))
"("                                (tok (OPEN-PAREN))
")"                                (tok (CLOSE-PAREN))
"["                                (tok (OPEN-BRACKET))
"]"                                (tok (CLOSE-BRACKET))
"{"                                (tok (OPEN-CURLY))
"}"                                (tok (CLOSE-CURLY))
","                                (tok (COMMA))
"="                                (tok (EQUAL))
"#"                                (tok (SHARP))
"@"                                (tok (ALPHA))
"&"                                (tok (AND))
"|"                                (tok (OR))
":"                                (tok (APP))
"/"                                (tok (INSERT))
"\\"                               (tok (INSERTRIGHT))
"~"                                (tok (CONST))
"`"                                (tok (EQO))
"*"                                (tok (LIFT))
"_"                                (tok (BOTTOM))
\10+                               (yycontinue)
\9+                                (yycontinue)
\13+                               (yycontinue)
\32+                               (yycontinue)
.                                  (let ((c (string-ref yytext 0)))
                                     (if (char<=? c #\space)
                                         (yycontinue)
                                         (tok (ID ,(string->symbol yytext)) ) ) )

<<EOF>>                            '*eoi*
<<ERROR>>                          (lexer-error (conc yyline ": illegal character") (yygetc))
