;;;; grammar.scm


(load "lalr.scm")

(lalr-parser
 (output: parser "grammar.lalr.scm")
   (ID NUM OPEN-SEQUENCE CLOSE-SEQUENCE OPEN-PAREN CLOSE-PAREN ALPHA EQUAL ATOM
	 COMMA OPEN-CURLY CLOSE-CURLY CONST OPEN-BRACKET CLOSE-BRACKET INSERT
	 DOTS SHARP DOT ARROW SEMICOLON APP DEBUG VERBATIM WHERE END
	 AND OR INSERTRIGHT WHILE BU CATCH CHAR EQO LIFT BOTTOM)
   (program
    (toplevel separator program) : (cons $1 $3)
    (toplevel separator) : (list $1)
    (toplevel) : (list $1) )
   (separator
    (COMMA) : $1
    (DOT) : $1)
   (toplevel
    (definition WHERE program END) : `(where ,$1 ,@$3)
    (definition) : $1
    (sequence) : $1
    (application) : $1)
   (application
    (expr APP object) : `(app ,$1 ,$3) )
   (definition 
     (head pconstruction EQUAL expr) : `(def ,$1
					     (cond ,$2 ,$4 
						   (bottom |failed match|)))
     (head EQUAL expr) : `(def ,$1 ,$3) )
   (head
    (OPEN-PAREN ID CLOSE-PAREN) : `(once ,(token-value $2))
    (ID) : (token-value $1) )
   (expr
    (expr1 ARROW expr1 SEMICOLON expr) : `(cond ,$1 ,$3 ,$5) 
    (expr1) : $1)
   (expr1
    (WHILE expr2 expr1) : `(while ,$2 ,$3)
    (CATCH expr2 expr) : `(catch ,$2 ,$3)
    (expr2 OR expr1) : `(comp (cond (select 1) (select 1) (comp ,$3 (select 2)))
			      (cons ,$1 id))
    (expr2 AND expr1) : `(cond ,$1 ,$3 (const (atom F)))
    (expr2 expr1) : `(comp ,$1 ,$2)
    (expr2) : $1)
   (expr2
    (BU value object) : `(bu ,$2 ,$3)
    (LIFT expr2) : `(comp apndl (cons (comp ,$2 (select 1)) (select -1)))
    (INSERT expr2) : `(insert ,$2)
    (INSERTRIGHT expr2) : `(insert-right ,$2)
    (ALPHA expr2) : `(alpha ,$2)
    (OPEN-PAREN expr CLOSE-PAREN) : $2
    (construction) : $1
    (pconstruction) : $1
    (value) : $1)
   (sequence
     (OPEN-SEQUENCE CLOSE-SEQUENCE) : '(seq)
     (OPEN-SEQUENCE object-list CLOSE-SEQUENCE) : `(seq ,@$2) )
   (expr-list
    (expr COMMA expr-list) : (cons $1 $3)
    (expr) : (list $1) )
   (pattern-list
    (pattern COMMA pattern-list) : (cons $1 $3)
    (pattern) : (list $1) )
   (pattern
    (ID EQUAL pattern) : `(let ,(token-value $1) ,$3)
    (ID EQUAL) : `(let ,(token-value $1) (const (atom T)))
    (SHARP) : '(const (atom T))
    (DOTS) : '...
    (expr) : $1)
   (object-list
    (object COMMA object-list) : (cons $1 $3)
    (object) : (list $1) )
   (construction
    (OPEN-BRACKET CLOSE-BRACKET): '(cons)
    (OPEN-BRACKET expr-list CLOSE-BRACKET) : `(cons ,@$2) )
   (pconstruction
    (OPEN-CURLY CLOSE-CURLY): '(pcons)
    (OPEN-CURLY pattern-list CLOSE-CURLY) : `(pcons ,@$2) )
   (value
    (BOTTOM) : '(bottom "undefined")
    (NUM) : `(select ,(token-value $1))
    (CONST object) : `(const ,$2)
    (EQO object) : `(bu eq ,$2)
    (ID) : (token-value $1)
    (VERBATIM ATOM) : `(verbatim ,(token-value $2))
    (DEBUG ATOM) : `(debug ,(token-value $2)) )
   (object
    (NUM) : (token-value $1)
    (CHAR) : (char->integer (token-value $1))
    (ATOM) : `(atom ,(token-value $1))
    (SHARP) : '(atom |#|)
    (VERBATIM ATOM) : `(verbatim ,(token-value $2))
    (sequence) : $1) )
